FEDS
====

Pomocná knihovna a CLI nástroj (https://github.com/viktorbezdek/feds-boilerplate)[Front-end Dev Stacku], která zajišťuje, nebo zprostředkovává vytváření projektů, generování součástí, instalaci refillů a knihoven.

<!-- MarkdownTOC depth=10 autolink=true autoanchor=true -->

- [Základní předpoklady][základní-předpoklady]
- [Instalace][instalace]
- [Použití][použití]
	- [Vytvoření nového projektu][vytvoření-nového-projektu]
	- [Instalace dependencí][instalace-dependencí]
	- [Vývojový build task][vývojový-build-task]
	- [Produkční build task][produkční-build-task]
	- [Generování součástí][generování-součástí]
	- [Instalace refillů][instalace-refillů]

<!-- /MarkdownTOC -->

<a name="základní-předpoklady"></a>
## Základní předpoklady

- základní zkušenost s command line nástroji
- NodeJS 0.12+
- NPM 2.7.0+

<a name="instalace"></a>
## Instalace

V terminálu nebo command promptu spusťte:

```bash

$ npm install -g feds-cli

```

<a name="použití"></a>
## Použití

<a name="vytvoření-nového-projektu"></a>
### Vytvoření nového projektu

V terminálu nebo command promptu spusťte:

```bash

$ feds --create jmeno_projektu cilovy_adresar repozitar_boilerplate

# nebo

$ feds -c jmeno_projektu cilovy_adresar repozitar_boilerplate

```

- **jmeno_projektu** může být jakýkoli řetězec, pokud obsahuje mezery nebo diakritiku, je třeba jej uzavřít do uvozovek (příklad: "Můj nový projekt")
- **cilovy_adresar** je cesta relativně od místa, kde byl příkaz `feds` spuštěný, a kde má být nový projekt vytvořený. Cílové místo _nesmí existovat_ (nástroj existující projekt nepřemaže)
- **repozitar_boilerplate** _NEPOVINNÉ_ je GitHub URL, kde je boilerplate projektu kompatibilní s FEDS. Používejte jen když opravdu víte co děláte.	

<a name="instalace-dependencí"></a>
### Instalace dependencí

Pro instalaci/reinstalaci dependencí, které vyžaduje nový projekt v terminálu nebo command promptu spusťte:

```bash

$ feds --install

# nebo

$ feds -i

```

<a name="vývojový-build-task"></a>
### Vývojový build task

Vývojový task je spuštěný zatím co pracujete, sleduje vaše soubory a po jejich změně je pomocí gulp tasků zpracovává, zajišťuje reload prohlížeče. Spouští se v terminálu nebo command promptu pomocí příkazu:

```bash

$ feds --development

# nebo

$ feds -d

```

<a name="produkční-build-task"></a>
### Produkční build task

Zpracuje a zoptimalizuje všechny soubory pro běh na produkčním serveru. Spouští se pomocí příkazu:

```bash

$ feds --build

# nebo

$ feds -b

```

<a name="generování-součástí"></a>
### Generování součástí

Vygeneruje součást (element, widget, dokumentaci, stránku...) ze šablony. 

**Součást se ukládá vždy do adresáře `app/views/druh_soucasti/nazev/`.**

Spouští se pomocí příkazu:

```bash

$ feds --generate druh_soucasti nazev

# nebo

$ feds -g druh_soucasti nazev

```

- **druh_soucasti** může být jedna z šablon `element`, `widget` a `page`
- **nazev** je jméno, jak se bude nová součást jmenovat. Jmén může být i více. Jméno může předcházet i cesta, kam má být součást uložena (relativně od obvyklého umístění). V případě větších aplikací je hlubší struktura doporučena.

<a name="instalace-refillů"></a>
### Instalace refillů

Nainstaluje FEDS refill (element, widget) z GitHubu do vašeho projektu.

**Součást se ukládá vždy do adresáře `app/views/druh_soucasti/nazev/`.**

Spouští se pomocí příkazu:

```bash

$ feds --refill nazev_refillu nazev

# nebo

$ feds -refill nazev_refillu nazev

```

- **nazev_refillu** je název refillu pro FEDS, který odpovídá názvu repository na GitHubu bez prefixu `feds-refill-`
- **nazev** je jméno, jak se bude nová součást jmenovat. Jmén může být i více. Jméno může předcházet i cesta, kam má být součást uložena (relativně od obvyklého umístění). V případě větších aplikací je hlubší struktura doporučena.

