'use strict';

var chalk = require('chalk');

/**
 * Handle async task stdout
 * @param  {ChildProcess} task_process Spawned task
 * @return
 */
function handle_task(task_process, done) {
  if (!opts) {
    var opts = {
      colorize: true
    };
  }

  var command_close_handler = function(code, signal) {
    done();
    // task_process.stdout.unref();
    // task_process.stderr.unref();
    // task_process.stdin.unref();
    process.exit(1);
  };

  // subprocess exit
  var command_exit_handler = function(code, signal) {
    // task_process.stdout.unref();
    // task_process.stderr.unref();
    // task_process.stdin.unref();
    process.exit(1);
  };

  // subprocess error
  var command_error_handler = function(err) {
    done(err);
    // task_process.stdout.unref();
    // task_process.stderr.unref();
    // task_process.stdin.unref();
    task_process.kill('SIGTERM');
    process.exit(1);
  };

  var command_buffer_handler = function(data) {
    //console.log(data.toString().replace(/(\n|\r)$/gim, ''));
    var stdout = data.toString();
    if (opts.colorize !== false) {
      if (!(/error:/gi).test(stdout)) {
        stdout = stdout
          .replace(/\[[0-9:]{6,10}\]/gi, chalk.white.bold('$&'))
          .replace(/[0-9.,]{1,32}\s\w/gi, chalk.white.bold('$&'))
          .replace(/gulp-[a-z]+/gi, chalk.blue.bold('$&'))
          .replace(/\'.+\'/gi, chalk.blue.bold('$&'))
          .replace(/finished|starting/gi, chalk.cyan.bold('$&'))
          .replace(/warning: .+/gi, chalk.yellow.bold('$&'))
          .replace(/doiuse: .+/gi, chalk.yellow.bold('$&'))
          .replace(/(\n|\r)$/g, '');
      } else {
        stdout = stdout
          .replace(/.+/gi, chalk.red('$&'))
          .replace(/(\n|\r)$/g, '');
      }
    }
    console.log(stdout);
    //console.log(data.toString());
  };

  // removed in favor of inheriting stdio
  // task_process.stdout.on('data', command_buffer_handler);
  // task_process.stderr.on('data', command_buffer_handler);
  // task_process.stdin.on('data', command_buffer_handler);

  task_process.on('close', command_close_handler);
  task_process.on('exit', command_exit_handler);
  task_process.on('error', command_error_handler);
}

module.exports = handle_task;
