var fse = require('fs-extra'),
	merge = require('package-merge'),
	path = require('path');



/**
 * Upgrades projects build scripts
 * @param  {[type]}   opts Upgrade options
 * @param  {Function} done Done callback
 * @return {void}
 */
module.exports = function(opts, done) {
	fse.emptyDirSync(path.join(process.cwd(), 'node_modules', 'feds-build-scripts'));
	require('spawn-npm-install').install(['feds-build-scripts'], {
		stdio: 'inherit',
		cwd: process.cwd()
	}, function() {
		var origPkg = fse.readFileSync('./package.json');
		var newPkg = fse.readFileSync('./node_modules/feds-build-scripts/package.json');
		var mergedPkg = merge(origPkg, newPkg);
		fse.writeFile('./package.json', mergedPkg, function(err) {
			if (err) throw err;
			done();
		});
	});
};
